import { homedir } from 'os';
import { join } from 'path';
import isMissionStarted from './utils/mission.util';

const deadlockConfigPath = join(homedir(), '.deadlock');

export const deadlockPath = '/deadlock';

export function getSshFolderPath() {
  return isMissionStarted() ? join(deadlockPath, '.ssh') : join(deadlockConfigPath, '.ssh');
}

export const DOCS_PATH_IC = `${homedir()}/docs`;

export const missionWorkdir = join(deadlockConfigPath, 'workspace');

export const GITEA_PATH_IC = '/project';

export const MISSION_PATH_IC = `${homedir()}/mission`;

export const MISSION_FILE_IC = join(deadlockPath, 'challenge.yaml');

export const DEADLOCK_WORKDIR_PATH = isMissionStarted() ? deadlockPath : deadlockConfigPath;

export const USER_MISSION_PATH = join('/home/config/user-challenge.json');

export const BRIEFING_FILE_NAME = 'briefing.md';

export const ENV_FILE_PATH = join(MISSION_PATH_IC, '.env');

export const BASHRC_PATH = join(homedir(), '.bashrc');

export const SERVICES_PATHS_PATH = join(MISSION_PATH_IC, 'paths.json');
