export interface DockerfileSpecific {
  image?: string;
  dockerFile?: string;
  context?: string;
  build?: { args: Record<string, string> };
  'build.target'?: string;
  'build.cacheFrom'?: string;
  containerEnv?: { [id: string]: string };
  containerUser?: string;
  mounts?: string[];
  workspaceMount?: string;
  workspaceFolder?: string;
  runArgs?: string[];
}

export interface Base {
  name?: string;
  forwardPorts?: string[];
  portsAttributes?: string[];
  otherPortsAttributes?: string[];
  remoteEnv?: { [id: string]: string };
  remoteUser?: string;
  updateRemoteUserUID?: string;
  userEnvProbe?: string;
  overrideCommand?: boolean;
  features?: string[];
  shutdownAction?: string;
}

export interface VSCodespecific {
  extensions?: string[];
  settings?: Record<string, unknown>;
  devPort?: string;
}

export interface LifecycleScripts {
  initializeCommand?: string;
  onCreateCommand?: string;
  updateContentCommand?: string;
  postCreateCommand?: string;
  postStartCommand?: string;
  postAttachCommand?: string;
  waitFor?: string;
}
