const logTemplate = (logFunction: (_: any, ...args: any[]) => void, prefix: string, message: any, ...args: any[]) => {
  logFunction(`[${prefix}] ${message}`, ...args);
};

export function error(message: any, ...args: any[]) {
  logTemplate(console.error, 'DEADLOCK-EXTENSION', message, ...args);
}

export function log(message: any, ...args: any[]) {
  logTemplate(console.log, 'DEADLOCK-EXTENSION', message, ...args);
}

export function warn(message: any, ...args: any[]) {
  logTemplate(console.warn, 'DEADLOCK-EXTENSION', message, ...args);
}
