import { existsSync, PathLike, readFileSync } from 'fs';
import { join } from 'path';
import { missionWorkdir, USER_MISSION_PATH } from '../config';
import UserMission from '../mission/model/userMission';

export function getReviewedStudentWorkdirPath(userId: string): string {
  return join(missionWorkdir, 'students', `${userId}`);
}

export function getUserChallenge(userId: string, missionid: string, isReviewing = false): UserMission {
  let path: number | PathLike;
  if (isMissionStarted()) {
    path = USER_MISSION_PATH;
  } else if (isReviewing) {
    path = join(getReviewedStudentWorkdirPath(userId), missionid, '.config', 'userChallenge.json');
  } else {
    path = join(missionWorkdir, missionid, '.config', 'userChallenge.json');
  }
  return JSON.parse(readFileSync(path, 'utf8'));
}

export default function isMissionStarted() {
  return existsSync(USER_MISSION_PATH);
}
