import { watch } from 'chokidar';

export default class FileWatcher {
  constructor(
    private folderToWatch: string,
    private watchFilePatterns: string[],
    private ignoreFilePatterns: string[],
    private onFilesChangeAction: () => void,
  ) {
    this.setupWatcher();
  }

  setupWatcher() {
    const watcher = watch(this.watchFilePatterns, {
      cwd: this.folderToWatch,
      ignored: this.ignoreFilePatterns,
      ignoreInitial: true,
    });
    watcher.on('change', this.onFilesChangeAction);
  }
}
